import { Component, OnInit, AfterViewInit, AfterContentInit, Input } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { Infra } from 'packages/infra/model';
import { Store, select } from '@ngrx/store';
import { ListSelector } from 'packages/infra/store';
import * as ListStore from 'packages/infra/store/list';
import { Page } from 'app/commons/model';
import { RPCClientError } from '@loafer/ng-rpc/protocol';
import { Probe } from 'packages/probe/model';

@Component({
    selector: 'of-target-list',
    templateUrl: './list.component.html',
})
export class ListComponent implements OnInit, AfterContentInit {

    infras$ = this.store.pipe(select(ListSelector.select('page')));
    infras: Infra[];
    probe: Probe;

    constructor(
        private route: ActivatedRoute,
        private router: Router,
        private store: Store<ListStore.State>
    ) {
        console.log('PROBE ID: ' + this.route.snapshot.paramMap.get('id'));
        this.getProbe();
    }

    ngOnInit() {
        this.infras$.subscribe(
            (page: Page) => {
                if (page) {
                    this.infras = page.content;
                }
            },
            (error: RPCClientError) => {
                console.log(error.response.message);
            }
        );
    }

    ngAfterContentInit() {
        // if (this.probe) {
        //     this.store.dispatch(new ListStore.ReadAllByProbe(this.probe));
        // }
    }

    getProbe() {

    }
}
